#include "Parser.h"
#include <stdio.h>
#include <stdlib.h>

char *NewLineCounter(Parser &p, char *sp, int *newlines);
char *SpaceCounter  (Parser &p, char *sp, int *spaces);

int main(void)
{
  int newlines = 1;
  int spaces   = 0;

  Parser p("Parser.cpp");

  p.AddTokenSeparator("\n"  , 0, -1, 1, (PARSER_CALLBACK)NewLineCounter, &newlines);
  p.AddTokenSeparator(" "   , 0, -1, 1, (PARSER_CALLBACK)SpaceCounter  , &spaces);

  free(p.GrabToken());

  printf("New Lines : %d\n", newlines);
  printf("Spaces    : %d\n", spaces);
  printf("Characters: %ld\n", p.GetFilePosition());

  return 0;
}

char *NewLineCounter(Parser &, char *sp, int *newlines)
{
  (*newlines)++;

  return sp;
}

char *SpaceCounter(Parser &, char *sp, int *spaces)
{
  (*spaces)++;

  return sp;
}
