#include <stdio.h>
#include <stdlib.h>

#include "Parser.h"

char *PrintCComment(Parser &p, char *comment, void *unused);
char *PrintCPPComment(Parser &p, char *comment, void *unused);

int main(void)
{
  char *buffer;
  Parser p("Parser.cpp", 1024);

  p.Enable(PARSER_REGULAR_EXPRESSIONS);
  if(p.AddTokenSeparator("//[^\n\r]*", 0, -1, 0, PrintCPPComment, 0))
    printf("Compile Error: CPP Style Comment\n");
  if(p.AddTokenSeparator("(/\\*([^*]|(\\*+[^*/]))*\\*+/)", 0, -1, 0, PrintCComment, 0))
    printf("Compile Error: C Style Comment\n");

  for(buffer = p.GrabToken(); buffer; buffer = p.GrabToken())
  {
    /*printf("%s\n", buffer);*/
    free(buffer);
  }

  return 0;
}

char *PrintCComment(Parser &, char *comment, void *unused)
{
  printf("C Style Comment--------------------\n");
  printf("%s\n\n", comment);
  return comment;
}

char *PrintCPPComment(Parser &, char *comment, void *unused)
{
  printf("C++ Style Comment------------------\n");
  printf("%s\n\n", comment);
  return comment;
}

