/*************************************************************
* Full Program - Retrieves the number of new lines from a file
*                                                           *
* Note: You must change <any file> in ParserInit() to the   *
*         name of the file you want to get the number of    *
*         new lines from.                                   *
*************************************************************/
#include "Parser.h"
#include <stdlib.h> /* free()   */
#include <stdio.h>  /* printf() */

char *NewLineCounter(char *sp, int *newlines);

int main(void)
{
  int newlines = 1;

  ParserInit("Parser.c", 1024);
  AddTokenSeparator("\n", 0, -1, 1, (PARSER_CALLBACK)NewLineCounter, &newlines);

  free(GrabToken()); /* Scan the whole file, and free what   *
                      * ever is returned                     */

  printf("New Lines: %d\n", newlines);

  ParserDeInit();

  return 0;
}

char *NewLineCounter(char *sp, int *newlines)
{
  (*newlines)++;

  return sp;
}
/*************************************************************
* End of the program                                        *
*************************************************************/
