#include <stdio.h>
#include <stdlib.h>

#include "Parser.h"

char *PrintCComment(char *comment, void *unused);
char *PrintCPPComment(char *comment, void *unused);

int main(void)
{
  char *buffer;
  ParserInit("Parser.c", 1024);

  ParserEnable(PARSER_REGULAR_EXPRESSIONS);
  if(AddTokenSeparator("//[^\n\r]*", 0, -1, 0, PrintCPPComment, 0))
    printf("Compile Error: CPP Style Comment\n");
  if(AddTokenSeparator("(/\\*([^*]|(\\*+[^*/]))*\\*+/)", 0, -1, 0, PrintCComment, 0))
    printf("Compile Error: C Style Comment\n");

  for(buffer = GrabToken(); buffer; buffer = GrabToken())
  {
    /*printf("%s\n", buffer);*/
    free(buffer);
  }

  ParserDeInit();

  return 0;
}

char *PrintCComment(char *comment, void *unused)
{
  printf("C Style Comment--------------------\n");
  printf("%s\n\n", comment);
  return comment;
}

char *PrintCPPComment(char *comment, void *unused)
{
  printf("C++ Style Comment------------------\n");
  printf("%s\n\n", comment);
  return comment;
}

