/************************************************************************
 * Start of Program. Prints out all comments and strings from Parser.c  *
 ************************************************************************/
#include "Parser.h"
#include <stdio.h>    /* printf()         */
#include <stdlib.h>   /* *alloc(), free() */

char *PrintString (char *sp, void *);
char *PrintComment(char *sp, void *);

int main(void)
{
  int   tset_strings;
  int   tset_comments;
  char *buffer;

  ParserInit("Parser.c", 1024);

  tset_strings  = AddTokenSet();
  tset_comments = AddTokenSet();

  SetTokenSet(0);
  AddTokenSeparator("\"", 0, tset_strings,  0, PrintString , 0);
  AddTokenSeparator("/*", 0, tset_comments, 0, PrintComment, 0);

    /* Set up the token set that will handle the strings */
  SetTokenSet(tset_strings);
  AddTokenSeparator("\\\\", 0, -1, 1, 0, 0);
  AddTokenSeparator("\\\"", 0, -1, 1, 0, 0);
  AddTokenSeparator("\"",   0,  0, 0, 0, 0);

    /* Set up the token set that will handle all comments */
  SetTokenSet(tset_comments);
  AddTokenSeparator("*/", 0, 0, 0, 0, 0);

  SetTokenSet(0);

    /* Loop through all the code. GrabToken() will return chunks of code*
     *   so, we need to free it until we get a null buffer/end of file  */
  for(buffer = GrabToken(); buffer; buffer = GrabToken())
    free(buffer);

  ParserDeInit();

  return 0;
}

char *PrintString(char *sp, void *a)
{
  char *buffer = GrabToken();
  a = a;
  printf("String Found!\n\"%s\"\n\n", buffer);
  free(buffer);

  return sp;  /* Don't return the " */
}

char *PrintComment(char *sp, void * a)
{
  char *buffer = GrabToken();
  a = a;
  printf("Comment Found!\n/*%s*/\n\n", buffer);
  free(buffer);

  return sp;  /* Don't return the / * */
}
/************************************************************************
 * End of Program                                                       *
 ************************************************************************/
